Files
apfstests/tests/generic/020
T
Christoph Hellwig c041421687 xfstests: stop special casing nfs and udf
For historical reasons beyond my knowledge xfstests tries to abuse the
scratch device as test device for nfs and udf.  Because not all test
have inherited the right usage of the _setup_testdir and _cleanup_testdir
helpers this leads to lots of unessecary test failures.

Remove the special casing, which gets nfs down to a minimal number of
failures.

Signed-off-by: Christoph Hellwig <hch@lst.de>
Reviewed-by: Eric Sandeen <sandeen@redhat.com>
Sugned-off-by: Dave Chinner <david@fromorbit.com>
2013-12-03 10:29:26 +11:00

177 lines
3.9 KiB
Bash
Executable File

#! /bin/bash
# FS QA Test No. 020
#
# extended attributes
#
#-----------------------------------------------------------------------
# Copyright (c) 2000-2002 Silicon Graphics, Inc. All Rights Reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it would be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
#
#-----------------------------------------------------------------------
#
seq=`basename $0`
seqres=$RESULT_DIR/$seq
echo "QA output created by $seq"
here=`pwd`
tmp=/tmp/$$
status=0 # success is the default!
trap "rm -f $tmp.* $testfile; exit \$status" 0 1 2 3 15
# get standard environment, filters and checks
. ./common/rc
. ./common/filter
. ./common/attr
_filter()
{
sed "s#$TEST_DIR[^ :]*#<TESTFILE>#g;
s#$tmp[^ :]*#<TMPFILE>#g" $1
}
_attr()
{
$ATTR_PROG $* 2>$tmp.err >$tmp.out
exit=$?
_filter $tmp.out
_filter $tmp.err 1>&2
return $exit
}
_getfattr()
{
$GETFATTR_PROG $* 2>$tmp.err >$tmp.out
exit=$?
_filter $tmp.out
_filter $tmp.err 1>&2
return $exit
}
_attr_list()
{
file=$1
echo " *** print attributes"
if ! _getfattr -d -e text --absolute-names $file
then
echo " !!! error return"
return 1
fi
}
# real QA test starts here
_supported_fs generic
_supported_os Linux
_require_attrs
rm -f $seqres.full
testfile=$TEST_DIR/attribute_$$
echo "*** list non-existant file"
_attr_list $testfile
echo "*** list empty file"
touch $testfile
_attr_list $testfile
echo "*** query non-existant attribute"
_attr -g "nonexistant" $testfile 2>&1
echo "*** one attribute"
echo "fish" | _attr -s fish $testfile
_attr_list $testfile
echo "*** replace attribute"
echo "fish3" | _attr -s fish $testfile
_attr_list $testfile
echo "*** add attribute"
echo "fish2" | _attr -s snrub $testfile
_attr_list $testfile
echo "*** remove attribute"
_attr -r fish $testfile
_attr_list $testfile
echo "*** add lots of attributes"
v=0
while [ $v -lt $MAX_ATTRS ]
do
echo -n "value_$v" | attr -s "attribute_$v" $testfile >>$seqres.full
if [ $? -ne 0 ]
then
echo "!!! failed to add \"attribute_$v\""
exit 1
fi
let "v = v + 1"
done
echo "*** check"
# don't print it all out...
getfattr --absolute-names $testfile \
| tee -a $seqres.full \
| $AWK_PROG '
/^#/ { next }
/^[ ]*$/ { next }
{ l++ }
END {print " *** " (l - 1) " attribute(s)" }' \
| sed s/$MAX_ATTRS/MAX_ATTRS/
echo "*** remove lots of attributes"
v=0
while [ $v -lt $MAX_ATTRS ]
do
if ! $ATTR_PROG -r "attribute_$v" $testfile >>$seqres.full
then
echo "!!! failed to remove \"attribute_$v\""
exit 1
fi
let "v = v + 1"
done
_attr_list $testfile
echo "*** really long value"
dd if=/dev/zero bs=1 count=$MAX_ATTRVAL_SIZE 2>/dev/null \
| _attr -s "long_attr" $testfile >/dev/null
OCTAL_SIZE=`echo "obase=8; $MAX_ATTRVAL_SIZE" | bc`
_attr -q -g "long_attr" $testfile | od -t x1 | sed -e "s/^0*$OCTAL_SIZE$/ATTRSIZE/"
_attr -r "long_attr" $testfile >/dev/null
echo "*** set/get/remove really long names (expect failure)"
short="XXXXXXXXXX"
long="$short$short$short$short$short$short$short$short$short$short"
vlong="$long$long$long"
_attr -s $vlong -V fish $testfile 2>&1 >/dev/null
_attr -g $vlong $testfile 2>&1 >/dev/null
_attr -r $vlong $testfile 2>&1 >/dev/null
echo "*** check final"
_attr_list $testfile
echo "*** delete"
rm -f $testfile
exit